"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from datetime import datetime
from panora_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from pydantic import model_serializer
from typing import TypedDict
from typing_extensions import NotRequired


class UnifiedAccountingIncomestatementOutputFieldMappingsTypedDict(TypedDict):
    r"""The custom field mappings of the object between the remote 3rd party & Panora"""


class UnifiedAccountingIncomestatementOutputFieldMappings(BaseModel):
    r"""The custom field mappings of the object between the remote 3rd party & Panora"""


class UnifiedAccountingIncomestatementOutputRemoteDataTypedDict(TypedDict):
    r"""The remote data of the income statement in the context of the 3rd Party"""


class UnifiedAccountingIncomestatementOutputRemoteData(BaseModel):
    r"""The remote data of the income statement in the context of the 3rd Party"""


class UnifiedAccountingIncomestatementOutputTypedDict(TypedDict):
    name: NotRequired[Nullable[str]]
    r"""The name of the income statement"""
    currency: NotRequired[Nullable[str]]
    r"""The currency used in the income statement"""
    start_period: NotRequired[Nullable[datetime]]
    r"""The start date of the period covered by the income statement"""
    end_period: NotRequired[Nullable[datetime]]
    r"""The end date of the period covered by the income statement"""
    gross_profit: NotRequired[Nullable[float]]
    r"""The gross profit for the period"""
    net_operating_income: NotRequired[Nullable[float]]
    r"""The net operating income for the period"""
    net_income: NotRequired[Nullable[float]]
    r"""The net income for the period"""
    field_mappings: NotRequired[
        Nullable[UnifiedAccountingIncomestatementOutputFieldMappingsTypedDict]
    ]
    r"""The custom field mappings of the object between the remote 3rd party & Panora"""
    id: NotRequired[Nullable[str]]
    r"""The UUID of the income statement record"""
    remote_id: NotRequired[Nullable[str]]
    r"""The remote ID of the income statement in the context of the 3rd Party"""
    remote_data: NotRequired[
        Nullable[UnifiedAccountingIncomestatementOutputRemoteDataTypedDict]
    ]
    r"""The remote data of the income statement in the context of the 3rd Party"""
    created_at: NotRequired[Nullable[datetime]]
    r"""The created date of the income statement record"""
    modified_at: NotRequired[Nullable[datetime]]
    r"""The last modified date of the income statement record"""


class UnifiedAccountingIncomestatementOutput(BaseModel):
    name: OptionalNullable[str] = UNSET
    r"""The name of the income statement"""

    currency: OptionalNullable[str] = UNSET
    r"""The currency used in the income statement"""

    start_period: OptionalNullable[datetime] = UNSET
    r"""The start date of the period covered by the income statement"""

    end_period: OptionalNullable[datetime] = UNSET
    r"""The end date of the period covered by the income statement"""

    gross_profit: OptionalNullable[float] = UNSET
    r"""The gross profit for the period"""

    net_operating_income: OptionalNullable[float] = UNSET
    r"""The net operating income for the period"""

    net_income: OptionalNullable[float] = UNSET
    r"""The net income for the period"""

    field_mappings: OptionalNullable[
        UnifiedAccountingIncomestatementOutputFieldMappings
    ] = UNSET
    r"""The custom field mappings of the object between the remote 3rd party & Panora"""

    id: OptionalNullable[str] = UNSET
    r"""The UUID of the income statement record"""

    remote_id: OptionalNullable[str] = UNSET
    r"""The remote ID of the income statement in the context of the 3rd Party"""

    remote_data: OptionalNullable[UnifiedAccountingIncomestatementOutputRemoteData] = (
        UNSET
    )
    r"""The remote data of the income statement in the context of the 3rd Party"""

    created_at: OptionalNullable[datetime] = UNSET
    r"""The created date of the income statement record"""

    modified_at: OptionalNullable[datetime] = UNSET
    r"""The last modified date of the income statement record"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = [
            "name",
            "currency",
            "start_period",
            "end_period",
            "gross_profit",
            "net_operating_income",
            "net_income",
            "field_mappings",
            "id",
            "remote_id",
            "remote_data",
            "created_at",
            "modified_at",
        ]
        nullable_fields = [
            "name",
            "currency",
            "start_period",
            "end_period",
            "gross_profit",
            "net_operating_income",
            "net_income",
            "field_mappings",
            "id",
            "remote_id",
            "remote_data",
            "created_at",
            "modified_at",
        ]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
