"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from .lineitem import LineItem, LineItemTypedDict
from datetime import datetime
from panora_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from pydantic import model_serializer
from typing import List, Optional, TypedDict
from typing_extensions import NotRequired


class UnifiedAccountingPaymentOutputFieldMappingsTypedDict(TypedDict):
    r"""The custom field mappings of the object between the remote 3rd party & Panora"""


class UnifiedAccountingPaymentOutputFieldMappings(BaseModel):
    r"""The custom field mappings of the object between the remote 3rd party & Panora"""


class UnifiedAccountingPaymentOutputRemoteDataTypedDict(TypedDict):
    r"""The remote data of the payment in the context of the 3rd Party"""


class UnifiedAccountingPaymentOutputRemoteData(BaseModel):
    r"""The remote data of the payment in the context of the 3rd Party"""


class UnifiedAccountingPaymentOutputTypedDict(TypedDict):
    invoice_id: NotRequired[Nullable[str]]
    r"""The UUID of the associated invoice"""
    transaction_date: NotRequired[Nullable[datetime]]
    r"""The date of the transaction"""
    contact_id: NotRequired[Nullable[str]]
    r"""The UUID of the associated contact"""
    account_id: NotRequired[Nullable[str]]
    r"""The UUID of the associated account"""
    currency: NotRequired[Nullable[str]]
    r"""The currency of the payment"""
    exchange_rate: NotRequired[Nullable[str]]
    r"""The exchange rate applied to the payment"""
    total_amount: NotRequired[Nullable[float]]
    r"""The total amount of the payment in cents"""
    type: NotRequired[Nullable[str]]
    r"""The type of payment"""
    company_info_id: NotRequired[Nullable[str]]
    r"""The UUID of the associated company info"""
    accounting_period_id: NotRequired[Nullable[str]]
    r"""The UUID of the associated accounting period"""
    tracking_categories: NotRequired[Nullable[List[str]]]
    r"""The UUIDs of the tracking categories associated with the payment"""
    line_items: NotRequired[List[LineItemTypedDict]]
    r"""The line items associated with this payment"""
    field_mappings: NotRequired[
        Nullable[UnifiedAccountingPaymentOutputFieldMappingsTypedDict]
    ]
    r"""The custom field mappings of the object between the remote 3rd party & Panora"""
    id: NotRequired[Nullable[str]]
    r"""The UUID of the payment record"""
    remote_id: NotRequired[Nullable[str]]
    r"""The remote ID of the payment in the context of the 3rd Party"""
    remote_updated_at: NotRequired[Nullable[datetime]]
    r"""The date when the payment was last updated in the remote system"""
    remote_data: NotRequired[
        Nullable[UnifiedAccountingPaymentOutputRemoteDataTypedDict]
    ]
    r"""The remote data of the payment in the context of the 3rd Party"""
    created_at: NotRequired[Nullable[datetime]]
    r"""The created date of the payment record"""
    modified_at: NotRequired[Nullable[datetime]]
    r"""The last modified date of the payment record"""


class UnifiedAccountingPaymentOutput(BaseModel):
    invoice_id: OptionalNullable[str] = UNSET
    r"""The UUID of the associated invoice"""

    transaction_date: OptionalNullable[datetime] = UNSET
    r"""The date of the transaction"""

    contact_id: OptionalNullable[str] = UNSET
    r"""The UUID of the associated contact"""

    account_id: OptionalNullable[str] = UNSET
    r"""The UUID of the associated account"""

    currency: OptionalNullable[str] = UNSET
    r"""The currency of the payment"""

    exchange_rate: OptionalNullable[str] = UNSET
    r"""The exchange rate applied to the payment"""

    total_amount: OptionalNullable[float] = UNSET
    r"""The total amount of the payment in cents"""

    type: OptionalNullable[str] = UNSET
    r"""The type of payment"""

    company_info_id: OptionalNullable[str] = UNSET
    r"""The UUID of the associated company info"""

    accounting_period_id: OptionalNullable[str] = UNSET
    r"""The UUID of the associated accounting period"""

    tracking_categories: OptionalNullable[List[str]] = UNSET
    r"""The UUIDs of the tracking categories associated with the payment"""

    line_items: Optional[List[LineItem]] = None
    r"""The line items associated with this payment"""

    field_mappings: OptionalNullable[UnifiedAccountingPaymentOutputFieldMappings] = (
        UNSET
    )
    r"""The custom field mappings of the object between the remote 3rd party & Panora"""

    id: OptionalNullable[str] = UNSET
    r"""The UUID of the payment record"""

    remote_id: OptionalNullable[str] = UNSET
    r"""The remote ID of the payment in the context of the 3rd Party"""

    remote_updated_at: OptionalNullable[datetime] = UNSET
    r"""The date when the payment was last updated in the remote system"""

    remote_data: OptionalNullable[UnifiedAccountingPaymentOutputRemoteData] = UNSET
    r"""The remote data of the payment in the context of the 3rd Party"""

    created_at: OptionalNullable[datetime] = UNSET
    r"""The created date of the payment record"""

    modified_at: OptionalNullable[datetime] = UNSET
    r"""The last modified date of the payment record"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = [
            "invoice_id",
            "transaction_date",
            "contact_id",
            "account_id",
            "currency",
            "exchange_rate",
            "total_amount",
            "type",
            "company_info_id",
            "accounting_period_id",
            "tracking_categories",
            "line_items",
            "field_mappings",
            "id",
            "remote_id",
            "remote_updated_at",
            "remote_data",
            "created_at",
            "modified_at",
        ]
        nullable_fields = [
            "invoice_id",
            "transaction_date",
            "contact_id",
            "account_id",
            "currency",
            "exchange_rate",
            "total_amount",
            "type",
            "company_info_id",
            "accounting_period_id",
            "tracking_categories",
            "field_mappings",
            "id",
            "remote_id",
            "remote_updated_at",
            "remote_data",
            "created_at",
            "modified_at",
        ]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
