"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from panora_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from pydantic import model_serializer
from typing import Any, Dict, TypedDict
from typing_extensions import NotRequired


class UnifiedCrmNoteInputTypedDict(TypedDict):
    content: Nullable[str]
    r"""The content of the note"""
    user_id: NotRequired[Nullable[str]]
    r"""The UUID of the user tied to the note"""
    company_id: NotRequired[Nullable[str]]
    r"""The UUID of the company tied to the note"""
    contact_id: NotRequired[Nullable[str]]
    r"""The UUID of the contact tied to the note"""
    deal_id: NotRequired[Nullable[str]]
    r"""The UUID of the deal tied to the note"""
    field_mappings: NotRequired[Nullable[Dict[str, Any]]]
    r"""The custom field mappings of the note between the remote 3rd party & Panora"""


class UnifiedCrmNoteInput(BaseModel):
    content: Nullable[str]
    r"""The content of the note"""

    user_id: OptionalNullable[str] = UNSET
    r"""The UUID of the user tied to the note"""

    company_id: OptionalNullable[str] = UNSET
    r"""The UUID of the company tied to the note"""

    contact_id: OptionalNullable[str] = UNSET
    r"""The UUID of the contact tied to the note"""

    deal_id: OptionalNullable[str] = UNSET
    r"""The UUID of the deal tied to the note"""

    field_mappings: OptionalNullable[Dict[str, Any]] = UNSET
    r"""The custom field mappings of the note between the remote 3rd party & Panora"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = [
            "user_id",
            "company_id",
            "contact_id",
            "deal_id",
            "field_mappings",
        ]
        nullable_fields = [
            "content",
            "user_id",
            "company_id",
            "contact_id",
            "deal_id",
            "field_mappings",
        ]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
