"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from panora_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from pydantic import model_serializer
from typing import Any, Dict, TypedDict
from typing_extensions import NotRequired


class UnifiedCrmTaskInputTypedDict(TypedDict):
    subject: Nullable[str]
    r"""The subject of the task"""
    content: Nullable[str]
    r"""The content of the task"""
    status: Nullable[str]
    r"""The status of the task. Authorized values are PENDING, COMPLETED."""
    due_date: NotRequired[Nullable[str]]
    r"""The due date of the task"""
    finished_date: NotRequired[Nullable[str]]
    r"""The finished date of the task"""
    user_id: NotRequired[Nullable[str]]
    r"""The UUID of the user tied to the task"""
    company_id: NotRequired[Nullable[str]]
    r"""The UUID of the company tied to the task"""
    deal_id: NotRequired[Nullable[str]]
    r"""The UUID of the deal tied to the task"""
    field_mappings: NotRequired[Nullable[Dict[str, Any]]]
    r"""The custom field mappings of the task between the remote 3rd party & Panora"""


class UnifiedCrmTaskInput(BaseModel):
    subject: Nullable[str]
    r"""The subject of the task"""

    content: Nullable[str]
    r"""The content of the task"""

    status: Nullable[str]
    r"""The status of the task. Authorized values are PENDING, COMPLETED."""

    due_date: OptionalNullable[str] = UNSET
    r"""The due date of the task"""

    finished_date: OptionalNullable[str] = UNSET
    r"""The finished date of the task"""

    user_id: OptionalNullable[str] = UNSET
    r"""The UUID of the user tied to the task"""

    company_id: OptionalNullable[str] = UNSET
    r"""The UUID of the company tied to the task"""

    deal_id: OptionalNullable[str] = UNSET
    r"""The UUID of the deal tied to the task"""

    field_mappings: OptionalNullable[Dict[str, Any]] = UNSET
    r"""The custom field mappings of the task between the remote 3rd party & Panora"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = [
            "due_date",
            "finished_date",
            "user_id",
            "company_id",
            "deal_id",
            "field_mappings",
        ]
        nullable_fields = [
            "subject",
            "content",
            "status",
            "due_date",
            "finished_date",
            "user_id",
            "company_id",
            "deal_id",
            "field_mappings",
        ]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
