"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from datetime import datetime
from panora_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from pydantic import model_serializer
from typing import List, TypedDict
from typing_extensions import NotRequired


class UnifiedHrisCompanyOutputFieldMappingsTypedDict(TypedDict):
    r"""The custom field mappings of the object between the remote 3rd party & Panora"""


class UnifiedHrisCompanyOutputFieldMappings(BaseModel):
    r"""The custom field mappings of the object between the remote 3rd party & Panora"""


class UnifiedHrisCompanyOutputRemoteDataTypedDict(TypedDict):
    r"""The remote data of the company in the context of the 3rd Party"""


class UnifiedHrisCompanyOutputRemoteData(BaseModel):
    r"""The remote data of the company in the context of the 3rd Party"""


class UnifiedHrisCompanyOutputTypedDict(TypedDict):
    legal_name: NotRequired[Nullable[str]]
    r"""The legal name of the company"""
    locations: NotRequired[Nullable[List[str]]]
    r"""UUIDs of the of the Location associated with the company"""
    display_name: NotRequired[Nullable[str]]
    r"""The display name of the company"""
    eins: NotRequired[Nullable[List[str]]]
    r"""The Employer Identification Numbers (EINs) of the company"""
    field_mappings: NotRequired[
        Nullable[UnifiedHrisCompanyOutputFieldMappingsTypedDict]
    ]
    r"""The custom field mappings of the object between the remote 3rd party & Panora"""
    id: NotRequired[Nullable[str]]
    r"""The UUID of the company record"""
    remote_id: NotRequired[Nullable[str]]
    r"""The remote ID of the company in the context of the 3rd Party"""
    remote_data: NotRequired[Nullable[UnifiedHrisCompanyOutputRemoteDataTypedDict]]
    r"""The remote data of the company in the context of the 3rd Party"""
    remote_created_at: NotRequired[Nullable[datetime]]
    r"""The date when the company was created in the 3rd party system"""
    created_at: NotRequired[Nullable[datetime]]
    r"""The created date of the company record"""
    modified_at: NotRequired[Nullable[datetime]]
    r"""The last modified date of the company record"""
    remote_was_deleted: NotRequired[Nullable[bool]]
    r"""Indicates if the company was deleted in the remote system"""


class UnifiedHrisCompanyOutput(BaseModel):
    legal_name: OptionalNullable[str] = UNSET
    r"""The legal name of the company"""

    locations: OptionalNullable[List[str]] = UNSET
    r"""UUIDs of the of the Location associated with the company"""

    display_name: OptionalNullable[str] = UNSET
    r"""The display name of the company"""

    eins: OptionalNullable[List[str]] = UNSET
    r"""The Employer Identification Numbers (EINs) of the company"""

    field_mappings: OptionalNullable[UnifiedHrisCompanyOutputFieldMappings] = UNSET
    r"""The custom field mappings of the object between the remote 3rd party & Panora"""

    id: OptionalNullable[str] = UNSET
    r"""The UUID of the company record"""

    remote_id: OptionalNullable[str] = UNSET
    r"""The remote ID of the company in the context of the 3rd Party"""

    remote_data: OptionalNullable[UnifiedHrisCompanyOutputRemoteData] = UNSET
    r"""The remote data of the company in the context of the 3rd Party"""

    remote_created_at: OptionalNullable[datetime] = UNSET
    r"""The date when the company was created in the 3rd party system"""

    created_at: OptionalNullable[datetime] = UNSET
    r"""The created date of the company record"""

    modified_at: OptionalNullable[datetime] = UNSET
    r"""The last modified date of the company record"""

    remote_was_deleted: OptionalNullable[bool] = UNSET
    r"""Indicates if the company was deleted in the remote system"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = [
            "legal_name",
            "locations",
            "display_name",
            "eins",
            "field_mappings",
            "id",
            "remote_id",
            "remote_data",
            "remote_created_at",
            "created_at",
            "modified_at",
            "remote_was_deleted",
        ]
        nullable_fields = [
            "legal_name",
            "locations",
            "display_name",
            "eins",
            "field_mappings",
            "id",
            "remote_id",
            "remote_data",
            "remote_created_at",
            "created_at",
            "modified_at",
            "remote_was_deleted",
        ]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
