"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from datetime import datetime
from panora_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from pydantic import model_serializer
from typing import List, TypedDict
from typing_extensions import NotRequired


class UnifiedHrisPayrollrunOutputFieldMappingsTypedDict(TypedDict):
    r"""The custom field mappings of the object between the remote 3rd party & Panora"""


class UnifiedHrisPayrollrunOutputFieldMappings(BaseModel):
    r"""The custom field mappings of the object between the remote 3rd party & Panora"""


class UnifiedHrisPayrollrunOutputRemoteDataTypedDict(TypedDict):
    r"""The remote data of the payroll run in the context of the 3rd Party"""


class UnifiedHrisPayrollrunOutputRemoteData(BaseModel):
    r"""The remote data of the payroll run in the context of the 3rd Party"""


class UnifiedHrisPayrollrunOutputTypedDict(TypedDict):
    run_state: NotRequired[Nullable[str]]
    r"""The state of the payroll run"""
    run_type: NotRequired[Nullable[str]]
    r"""The type of the payroll run"""
    start_date: NotRequired[Nullable[datetime]]
    r"""The start date of the payroll run"""
    end_date: NotRequired[Nullable[datetime]]
    r"""The end date of the payroll run"""
    check_date: NotRequired[Nullable[datetime]]
    r"""The check date of the payroll run"""
    field_mappings: NotRequired[
        Nullable[UnifiedHrisPayrollrunOutputFieldMappingsTypedDict]
    ]
    r"""The custom field mappings of the object between the remote 3rd party & Panora"""
    id: NotRequired[Nullable[str]]
    r"""The UUID of the payroll run record"""
    remote_id: NotRequired[Nullable[str]]
    r"""The remote ID of the payroll run in the context of the 3rd Party"""
    remote_data: NotRequired[Nullable[UnifiedHrisPayrollrunOutputRemoteDataTypedDict]]
    r"""The remote data of the payroll run in the context of the 3rd Party"""
    remote_created_at: NotRequired[Nullable[datetime]]
    r"""The date when the payroll run was created in the 3rd party system"""
    created_at: NotRequired[Nullable[datetime]]
    r"""The created date of the payroll run record"""
    modified_at: NotRequired[Nullable[datetime]]
    r"""The last modified date of the payroll run record"""
    remote_was_deleted: NotRequired[Nullable[bool]]
    r"""Indicates if the payroll run was deleted in the remote system"""
    employee_payroll_runs: NotRequired[Nullable[List[str]]]
    r"""The UUIDs of the employee payroll runs associated with this payroll run"""


class UnifiedHrisPayrollrunOutput(BaseModel):
    run_state: OptionalNullable[str] = UNSET
    r"""The state of the payroll run"""

    run_type: OptionalNullable[str] = UNSET
    r"""The type of the payroll run"""

    start_date: OptionalNullable[datetime] = UNSET
    r"""The start date of the payroll run"""

    end_date: OptionalNullable[datetime] = UNSET
    r"""The end date of the payroll run"""

    check_date: OptionalNullable[datetime] = UNSET
    r"""The check date of the payroll run"""

    field_mappings: OptionalNullable[UnifiedHrisPayrollrunOutputFieldMappings] = UNSET
    r"""The custom field mappings of the object between the remote 3rd party & Panora"""

    id: OptionalNullable[str] = UNSET
    r"""The UUID of the payroll run record"""

    remote_id: OptionalNullable[str] = UNSET
    r"""The remote ID of the payroll run in the context of the 3rd Party"""

    remote_data: OptionalNullable[UnifiedHrisPayrollrunOutputRemoteData] = UNSET
    r"""The remote data of the payroll run in the context of the 3rd Party"""

    remote_created_at: OptionalNullable[datetime] = UNSET
    r"""The date when the payroll run was created in the 3rd party system"""

    created_at: OptionalNullable[datetime] = UNSET
    r"""The created date of the payroll run record"""

    modified_at: OptionalNullable[datetime] = UNSET
    r"""The last modified date of the payroll run record"""

    remote_was_deleted: OptionalNullable[bool] = UNSET
    r"""Indicates if the payroll run was deleted in the remote system"""

    employee_payroll_runs: OptionalNullable[List[str]] = UNSET
    r"""The UUIDs of the employee payroll runs associated with this payroll run"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = [
            "run_state",
            "run_type",
            "start_date",
            "end_date",
            "check_date",
            "field_mappings",
            "id",
            "remote_id",
            "remote_data",
            "remote_created_at",
            "created_at",
            "modified_at",
            "remote_was_deleted",
            "employee_payroll_runs",
        ]
        nullable_fields = [
            "run_state",
            "run_type",
            "start_date",
            "end_date",
            "check_date",
            "field_mappings",
            "id",
            "remote_id",
            "remote_data",
            "remote_created_at",
            "created_at",
            "modified_at",
            "remote_was_deleted",
            "employee_payroll_runs",
        ]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
