"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from panora_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from pydantic import model_serializer
from typing import TypedDict
from typing_extensions import NotRequired


class UnifiedHrisTimeoffbalanceOutputFieldMappingsTypedDict(TypedDict):
    r"""The custom field mappings of the object between the remote 3rd party & Panora"""


class UnifiedHrisTimeoffbalanceOutputFieldMappings(BaseModel):
    r"""The custom field mappings of the object between the remote 3rd party & Panora"""


class UnifiedHrisTimeoffbalanceOutputRemoteDataTypedDict(TypedDict):
    r"""The remote data of the time off balance in the context of the 3rd Party"""


class UnifiedHrisTimeoffbalanceOutputRemoteData(BaseModel):
    r"""The remote data of the time off balance in the context of the 3rd Party"""


class UnifiedHrisTimeoffbalanceOutputTypedDict(TypedDict):
    balance: NotRequired[Nullable[float]]
    r"""The current balance of time off"""
    employee_id: NotRequired[Nullable[str]]
    r"""The UUID of the associated employee"""
    used: NotRequired[Nullable[float]]
    r"""The amount of time off used"""
    policy_type: NotRequired[Nullable[str]]
    r"""The type of time off policy"""
    field_mappings: NotRequired[
        Nullable[UnifiedHrisTimeoffbalanceOutputFieldMappingsTypedDict]
    ]
    r"""The custom field mappings of the object between the remote 3rd party & Panora"""
    id: NotRequired[Nullable[str]]
    r"""The UUID of the time off balance record"""
    remote_id: NotRequired[Nullable[str]]
    r"""The remote ID of the time off balance in the context of the 3rd Party"""
    remote_data: NotRequired[
        Nullable[UnifiedHrisTimeoffbalanceOutputRemoteDataTypedDict]
    ]
    r"""The remote data of the time off balance in the context of the 3rd Party"""
    remote_created_at: NotRequired[Nullable[str]]
    r"""The date when the time off balance was created in the 3rd party system"""
    created_at: NotRequired[Nullable[str]]
    r"""The created date of the time off balance record"""
    modified_at: NotRequired[Nullable[str]]
    r"""The last modified date of the time off balance record"""
    remote_was_deleted: NotRequired[Nullable[bool]]
    r"""Indicates if the time off balance was deleted in the remote system"""


class UnifiedHrisTimeoffbalanceOutput(BaseModel):
    balance: OptionalNullable[float] = UNSET
    r"""The current balance of time off"""

    employee_id: OptionalNullable[str] = UNSET
    r"""The UUID of the associated employee"""

    used: OptionalNullable[float] = UNSET
    r"""The amount of time off used"""

    policy_type: OptionalNullable[str] = UNSET
    r"""The type of time off policy"""

    field_mappings: OptionalNullable[UnifiedHrisTimeoffbalanceOutputFieldMappings] = (
        UNSET
    )
    r"""The custom field mappings of the object between the remote 3rd party & Panora"""

    id: OptionalNullable[str] = UNSET
    r"""The UUID of the time off balance record"""

    remote_id: OptionalNullable[str] = UNSET
    r"""The remote ID of the time off balance in the context of the 3rd Party"""

    remote_data: OptionalNullable[UnifiedHrisTimeoffbalanceOutputRemoteData] = UNSET
    r"""The remote data of the time off balance in the context of the 3rd Party"""

    remote_created_at: OptionalNullable[str] = UNSET
    r"""The date when the time off balance was created in the 3rd party system"""

    created_at: OptionalNullable[str] = UNSET
    r"""The created date of the time off balance record"""

    modified_at: OptionalNullable[str] = UNSET
    r"""The last modified date of the time off balance record"""

    remote_was_deleted: OptionalNullable[bool] = UNSET
    r"""Indicates if the time off balance was deleted in the remote system"""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = [
            "balance",
            "employee_id",
            "used",
            "policy_type",
            "field_mappings",
            "id",
            "remote_id",
            "remote_data",
            "remote_created_at",
            "created_at",
            "modified_at",
            "remote_was_deleted",
        ]
        nullable_fields = [
            "balance",
            "employee_id",
            "used",
            "policy_type",
            "field_mappings",
            "id",
            "remote_id",
            "remote_data",
            "remote_created_at",
            "created_at",
            "modified_at",
            "remote_was_deleted",
        ]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
